#include "ty_flash.h"
#include "ty_system.h"
#include "tuya_ble_log.h"

#include "vendor/8258_module/battery_check.h"

/*********************************************************************
 * LOCAL CONSTANT
 */
            
/*********************************************************************
 * LOCAL STRUCT
 */

/*********************************************************************
 * LOCAL VARIABLE
 */
/*********************************************************************
 * VARIABLE
 */

/*********************************************************************
 * LOCAL FUNCTION
 */


/*********************************************************
FN: 
*/
uint32_t ty_flash_init(void)
{
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_flash_read(uint32_t addr, uint8_t* buf, uint32_t size)
{
    ty_system_wdt_feed();

	flash_read_page(addr,size,buf);
    return TUYA_BLE_SUCCESS;
}

/*********************************************************
FN: 
*/
uint32_t ty_flash_write(uint32_t addr, const uint8_t* buf, uint32_t size)
{
	TUYA_APP_LOG_DEBUG("flash_write_page-0x%08x,%d",addr,size);

    unsigned int offset = addr&0xff;
	unsigned int write_len = 0;
	unsigned int write_offset = 0;
	uint8_t *addr_data = (uint8_t*)buf;

    #if (BATT_CHECK_ENABLE)
	if(battery_get_detect_enable()){
		if(analog_read(USED_DEEP_ANA_REG) & LOW_BATT_FLG){
			app_battery_power_check(VBAT_ALRAM_THRES_MV + 200);  //2.2 V
		}
		else{
			app_battery_power_check(VBAT_ALRAM_THRES_MV);  //2.0 V
		}
	}
	#endif
	
    for(write_offset=0; write_offset<size; write_offset+=write_len)
	{
		if((size - write_offset) > (256 - offset))
		{
			write_len = 256 - offset;
		}
		else
		{
			write_len = size - write_offset;
		}
        
        ty_system_wdt_feed();
		
        flash_write_page(addr+write_offset, write_len, addr_data+write_offset);
		offset = (addr+write_len)& 0xff;
	}

    return TUYA_BLE_SUCCESS;
}

/*********************************************************
FN: 
*/
uint32_t ty_flash_erase(uint32_t addr, uint32_t num)
{
    #if (BATT_CHECK_ENABLE)
	if(battery_get_detect_enable()){
		if(analog_read(USED_DEEP_ANA_REG) & LOW_BATT_FLG){
			app_battery_power_check(VBAT_ALRAM_THRES_MV + 200);  //2.2 V
		}
		else{
			app_battery_power_check(VBAT_ALRAM_THRES_MV);  //2.0 V
		}
	}
	#endif
    
    ty_system_wdt_feed();

    for (uint8_t i = 0; i < num; i++)
   	{
        flash_erase_sector(addr + (4096 * i));
    }
    return TUYA_BLE_SUCCESS;
}






