#include "ty_rtc.h"

/*********************************************************************
 * LOCAL CONSTANT
 */

/*********************************************************************
 * LOCAL STRUCT
 */

/*********************************************************************
 * LOCAL VARIABLE
 */
static uint32_t s_local_timestamp = 0;
static uint32_t s_local_timestamp_when_update = 0;
static uint32_t s_app_timestamp_when_update = 0;

typedef struct
{
    uint32_t  local_timestamp;
    uint32_t  local_timezone;
}Sys_timestamp;

_attribute_data_retention_	Sys_timestamp	sys_timestamp;
_attribute_data_retention_  uint32_t  ble_timer_clock;
/*********************************************************************
 * VARIABLE
 */

/*********************************************************************
 * LOCAL FUNCTION
 */


/*********************************************************
FN: 
*/
uint32_t ty_rtc_init(void)
{
    uint32_t ret;
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_set_time(uint32_t timestamp)
{
	sys_timestamp.local_timestamp = timestamp;
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_get_time(uint32_t* p_timestamp)
{
	*p_timestamp = sys_timestamp.local_timestamp;
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_set_zone(uint32_t zonestamp)
{
	sys_timestamp.local_timezone = zonestamp;
    return 0;
}

/*********************************************************
FN:
*/
uint32_t ty_rtc_get_zone(uint32_t* p_zonestamp)
{
	*p_zonestamp = sys_timestamp.local_timezone;
    return 0;
}

/*********************************************************
FN:
*/
uint32_t ty_rtc_get_local_time(uint32_t* p_timestamp)
{
    *p_timestamp = s_local_timestamp;
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_get_old_time(uint32_t old_local_timestamp, uint32_t* p_timestamp)
{
    uint32_t timestamp = 0;
    ty_rtc_get_time(&timestamp);
    *p_timestamp = (timestamp - (s_local_timestamp - old_local_timestamp));
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_control(uint8_t cmd, void* arg)
{
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_rtc_uninit(void)
{
    return 0;
}

/*返回经过了多少秒*/
uint32_t  ty_timer_process(void)
{
	uint32_t  seconds;
	uint32_t  tick_last = ble_timer_clock;
	uint32_t  tick_pass = 0;
	uint32_t  tick_now = clock_time();
	if(tick_now > tick_last)
	{
		tick_pass = tick_now - tick_last;
	}
	else
	{
		tick_pass = 0xFFFFFFFF - tick_last + tick_now;
	}
	seconds = tick_pass/CLOCK_SYS_CLOCK_1S;
    if(seconds > 0)
    {
    	ble_timer_clock += seconds*CLOCK_SYS_CLOCK_1S;
    	sys_timestamp.local_timestamp += seconds; //unix time
    }
    return  seconds;
}






