/**
****************************************************************************
* @file      ty_template.h
* @brief     ty_template
* @author    suding
* @version   V1.0.0
* @date      2020-10
* @note
******************************************************************************
* @attention
*
* <h2><center>&copy; COPYRIGHT 2020 Tuya </center></h2>
*/


#ifndef __TY_TEMPLATE_H__
#define __TY_TEMPLATE_H__

#ifdef __cplusplus
extern "C"
{
#endif

/*********************************************************************
 * INCLUDE
 */
#include "common/types.h"
#include "common/string.h"
#include "tuya_ble_type.h"
#include "elog.h"
#include "tl_common.h"
#include "drivers.h"


/*********************************************************************
 * CONSTANT
 */
#define TY_LOG_ENABLE 	TUYA_BLE_LOG_ENABLE||TUYA_APP_LOG_ENABLE
#if (TY_LOG_ENABLE)
    #define TY_PRINTF(...)        log_d(__VA_ARGS__)
    #define TY_HEXDUMP(...)       ty_system_log_hexdump("", 8, __VA_ARGS__)
#else
    #define TY_PRINTF(...)
    #define TY_HEXDUMP(...)
#endif
#define BOARD_FLASH_BULK_DATA_START_ADDR        0x7C000
#define BOARD_FLASH_TUYA_INFO_START_ADDR        0x78000

#define BOARD_PWM_PIN                           GPIO_PB4
#define BOARD_ADC_PIN                           GPIO_PB5
#define BOARD_ADC_CHANNEL                       B5P

/*********************************************************************
 * STRUCT
 */

/*********************************************************************
 * EXTERNAL VARIABLE
 */

/*********************************************************************
 * EXTERNAL FUNCTION
 */


#ifdef __cplusplus
}
#endif

#endif //__TY_TEMPLATE_H__
